//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  DimGray
#property indicator_color2  DimGray
#property indicator_color3  DimGray
#property indicator_color4  SteelBlue
#property indicator_color5  Gold
#property indicator_color6  SteelBlue
#property indicator_color7  DeepSkyBlue
#property indicator_color8  Red
#property indicator_width5  2
#property indicator_width7  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern string TimeFrame                = "Current time frame";
extern int    RsiPeriod                = 13;
extern int    RsiPrice                 = PRICE_CLOSE;
extern int    RsiPriceLinePeriod       = 2;
extern int    RsiPriceLineMAMode       = MODE_SMA;
extern int    RsiSignalLinePeriod      = 7;
extern int    RsiSignalLineMAMode      = MODE_SMA;
extern int    VolatilityBandPeriod     = 34;
extern int    VolatilityBandMAMode     = MODE_SMA;
extern double VolatilityBandMultiplier = 1.6185;
extern int    ChartAlignmentPeriod     = 20;
extern int    ChartAlignmentMaMode     = MODE_EMA;
extern int    ChartAlignmentPrice      = PRICE_TYPICAL;
extern double ChartAlignmentDeviations = 3;
extern double LevelDown                = 32;
extern double LevelMiddle              = 50;
extern double LevelUp                  = 68;
extern bool   Interpolate              = true;
extern bool   alertsOn                 = false;
extern bool   alertsOnCurrent          = true;
extern bool   alertsMessage            = true;
extern bool   alertsSound              = false;
extern bool   alertsEmail              = false;

//
//
//
//
//

double rsiPriceLine[];
double rsiSignalLine[];
double bandUp[];
double bandMiddle[];
double bandDown[];
double levelDown[];
double levelMiddle[];
double levelUp[];
double trend[];
double rsi[];
double mid[];
double price[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init() 
{
   SetIndexBuffer(0,levelUp);     SetIndexLabel(0,NULL);
   SetIndexBuffer(1,levelMiddle); SetIndexLabel(1,NULL);
   SetIndexBuffer(2,levelDown);   SetIndexLabel(2,NULL);
   SetIndexBuffer(3,bandUp);
   SetIndexBuffer(4,bandMiddle);
   SetIndexBuffer(5,bandDown);
   SetIndexBuffer(6,rsiPriceLine);
   SetIndexBuffer(7,rsiSignalLine);

      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //

   IndicatorShortName(timeFrameToString(timeFrame)+" Traders dynamic index");
   return (0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bandUp[0] = limit+1; return(0); }
         if (ArraySize(trend)!=Bars) ArrayResize(trend,Bars);

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (ArraySize(rsi) != Bars)
      {
         ArrayResize(rsi  ,Bars);
         ArrayResize(mid  ,Bars);
         ArrayResize(price,Bars);
      }         
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         price[r]   = iMA(NULL,0,1,0,MODE_SMA,ChartAlignmentPrice,i);
         mid[r]     = iCustomMa(ChartAlignmentMaMode,price,ChartAlignmentPeriod,i,3);
         double dev = iDeviation(price,ChartAlignmentPeriod,mid[r],r)/(50.0/ChartAlignmentDeviations);

            //
            //
            //
            //
            //
            
            levelUp[i]       = mid[r]+dev*(LevelUp    -50.0);
            levelMiddle[i]   = mid[r]+dev*(LevelMiddle-50.0);
            levelDown[i]     = mid[r]+dev*(LevelDown  -50.0);
            rsi[r]           = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
            rsiPriceLine[i]  = mid[r]+(iCustomMa(RsiPriceLineMAMode,rsi,RsiPriceLinePeriod,i,0)  -50)*dev;
            rsiSignalLine[i] = mid[r]+(iCustomMa(RsiSignalLineMAMode,rsi,RsiSignalLinePeriod,i,1)-50)*dev;
               double average   = iCustomMa(VolatilityBandMAMode,rsi,VolatilityBandPeriod,i,2);
               double deviation = iDeviation(rsi,VolatilityBandPeriod,average,r);
                  bandUp[i]     = mid[r]+((average+VolatilityBandMultiplier*deviation)-50)*dev;
                  bandDown[i]   = mid[r]+((average-VolatilityBandMultiplier*deviation)-50)*dev;
                  bandMiddle[i] = mid[r]+((average)-50)*dev;
                  trend[r]      = trend[r-1];
                     if (rsiPriceLine[i]>rsiSignalLine[i]) trend[r] =  1;
                     if (rsiPriceLine[i]<rsiSignalLine[i]) trend[r] = -1;
      }
      manageAlerts();
      return (0);
   }

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         levelUp[i]       = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,ChartAlignmentPeriod,ChartAlignmentMaMode,ChartAlignmentPrice,ChartAlignmentDeviations,0,y);
         levelMiddle[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,ChartAlignmentPeriod,ChartAlignmentMaMode,ChartAlignmentPrice,ChartAlignmentDeviations,1,y);
         levelDown[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,ChartAlignmentPeriod,ChartAlignmentMaMode,ChartAlignmentPrice,ChartAlignmentDeviations,2,y);
         bandUp[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,ChartAlignmentPeriod,ChartAlignmentMaMode,ChartAlignmentPrice,ChartAlignmentDeviations,3,y);
         bandMiddle[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,ChartAlignmentPeriod,ChartAlignmentMaMode,ChartAlignmentPrice,ChartAlignmentDeviations,4,y);
         bandDown[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,ChartAlignmentPeriod,ChartAlignmentMaMode,ChartAlignmentPrice,ChartAlignmentDeviations,5,y);
         rsiPriceLine[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,ChartAlignmentPeriod,ChartAlignmentMaMode,ChartAlignmentPrice,ChartAlignmentDeviations,6,y);
         rsiSignalLine[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,ChartAlignmentPeriod,ChartAlignmentMaMode,ChartAlignmentPrice,ChartAlignmentDeviations,7,y);
         trend[r]         = trend[r-1];
               if (rsiPriceLine[i]>rsiSignalLine[i]) trend[r] =  1;
               if (rsiPriceLine[i]<rsiSignalLine[i]) trend[r] = -1;

         //
         //
         //
         //
         //
      
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               levelUp[i+k]       = levelUp[i]       + (levelUp[i+n]       - levelUp[i]      )*k/n;
               levelMiddle[i+k]   = levelMiddle[i]   + (levelMiddle[i+n]   - levelMiddle[i]  )*k/n;
               levelDown[i+k]     = levelDown[i]     + (levelDown[i+n]     - levelDown[i]    )*k/n;
               bandUp[i+k]        = bandUp[i]        + (bandUp[i+n]        - bandUp[i]       )*k/n;
               bandMiddle[i+k]    = bandMiddle[i]    + (bandMiddle[i+n]    - bandMiddle[i]   )*k/n;
               bandDown[i+k]      = bandDown[i]      + (bandDown[i+n]      - bandDown[i]     )*k/n;
               rsiPriceLine[i+k]  = rsiPriceLine[i]  + (rsiPriceLine[i+n]  - rsiPriceLine[i] )*k/n;
               rsiSignalLine[i+k] = rsiSignalLine[i] + (rsiSignalLine[i+n] - rsiSignalLine[i])*k/n;
            }               
   }

   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double iDeviation(double& array[], double period, double ma, int r)
{
   double sum = 0.00;
      for(int k=0; k<period; k++) sum += (array[r-k]-ma)*(array[r-k]-ma);
   return(MathSqrt(sum/period));
}

double iCustomMa(int mode, double& array[], double length, int i, int forInstance)
{
   int r = Bars-i-1;
   switch (mode)
   {
      case 0  : return(iSma(array[r],length,r,forInstance));
      case 1  : return(iEma(array[r],length,r,forInstance));
      case 2  : return(iSmma(array[r],length,r,forInstance));
      case 3  : return(iLwma(array[r],length,r,forInstance));
      default : return(iZeroLag(array[r],length,r,forInstance));
   }
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

#define _instances 4
double workSma[][_instances];
double iSma(double tprice, double period, int r, int forInstance=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars);

   //
   //
   //
   //
   //
      
   workSma[r][forInstance] = tprice;
   double sum = tprice; 
         for(int k=1; k<period && (r-k)>=0; k++) sum += workSma[r-k][forInstance];  
   return(sum/k);
}

//
//
//
//
//

double workEma[][_instances];
double iEma(double tprice, double period, int r, int forInstance=0)
{
   if (ArraySize(workEma)!= Bars) ArrayResize(workEma,Bars);

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][forInstance] = workEma[r-1][forInstance]+alpha*(tprice-workEma[r-1][forInstance]);
   return(workEma[r][forInstance]);
}
//
//
//
//
//

double workSmma[][_instances];
double workSmmp[][_instances];
double iSmma(double tprice, double period, int r, int forInstance=0)
{
   if (ArraySize(workSmma)!= Bars) ArrayResize(workSmma,Bars);
   if (ArraySize(workSmmp)!= Bars) ArrayResize(workSmmp,Bars);

   //
   //
   //
   //
   //
      
   if (r<period)
   {
      workSmmp[r][forInstance] = tprice;
      workSmma[r][forInstance] = tprice; 
         for(int k=1; k<period && (r-k)>=0; k++) workSmma[r][forInstance] += workSmmp[r-k][forInstance];  
                                                 workSmma[r][forInstance] /= k;
   }      
   else   workSmma[r][forInstance] = (workSmma[r-1][forInstance]*(period-1)+tprice)/period;
   return(workSmma[r][forInstance]);
}

//
//
//
//
//

double workLwma[][_instances];
double iLwma(double tprice, double period, int r, int forInstance=0)
{
   if (ArrayRange(workLwma,0)!= Bars) ArrayResize(workLwma,Bars);
   
   //
   //
   //
   //
   //
   
   workLwma[r][forInstance] = tprice;
      double sum  = 0;
      double sumw = 0;

      for(int k=0; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][forInstance];  
      }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double workZl[][8];
#define _ema1 0
#define _ema2 1

double iZeroLag(double tprice, double length, int r, int forInstance)
{
   if (ArrayRange(workZl,0)!=Bars) ArrayResize(workZl,Bars);

   //
   //
   //
   //
   //
      
   double alpha = 2.0/(length+1.0); forInstance *= 2;
      workZl[r][_ema1+forInstance] = workZl[r-1][_ema1+forInstance]+alpha*(tprice                      -workZl[r-1][_ema1+forInstance]);
      workZl[r][_ema2+forInstance] = workZl[r-1][_ema2+forInstance]+alpha*(workZl[r][_ema1+forInstance]-workZl[r-1][_ema2+forInstance]);
   return(2.0*workZl[r][_ema1+forInstance]-workZl[r][_ema2+forInstance]);
      
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[Bars-whichBar-1] != trend[Bars-whichBar-2])
      {
         if (trend[Bars-whichBar-1] == 1) doAlert(whichBar,"up");
         if (trend[Bars-whichBar-1] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TDI price line crossed signal line ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"TDI "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

